﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
#Event: Click
#Event: LongClick
#Event: ChangeCompleted

Sub Class_Globals

   Private mTarget As Object
   Private mEventName As String
	
	Private mBase As Panel
	Private pnlTextBack As Panel
	Private pnlTextFore As Panel

	Private mSliceW As Int
	Private mCnvText As Canvas
	Private mrecText As Rect
	Private X_CnvText, Y_CnvText As Float
	Private Max_X_CnvText As Float

	Private tmrText As Timer
	
#Region  + MEMBER VARIABLES 
	Private mText As String
	Private mTypeFace1 As Typeface
	Private mTextSize As Int
	Private mAlign1 As String
	Private mTextColor, mNewTextColor As Int
	Private mColor As Int
#End Region

End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
   mTarget = TargetModule
   mEventName = EventName
	
	tmrText.Initialize("tmrText", 50) ' TODO interval
	
	' TODO Calculate
	mSliceW = 2dip

End Sub


Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	Base.Color = Colors.Transparent
	
	pnlTextBack.Initialize("pnlTextBack")
	Base.AddView(pnlTextBack, 0, 0, Base.Width, Base.Height)
	pnlTextFore.Initialize("pnlTextFore")
	Base.AddView(pnlTextFore, 0, 0, Base.Width, Base.Height)
	pnlTextFore.BringToFront
	
	mText = Lbl.Text
	mTextSize = Lbl.TextSize
	mTypeFace1 = Lbl.Typeface
	mTextColor = Lbl.TextColor
	mNewTextColor = Colors.DarkGray
	mAlign1 = "CENTER"

	mrecText.Initialize(0, 0, mSliceW, Base.Height)

End Sub


#Region  + PROPERTIES 

#Region  Text 
Public Sub setText(Text As String)
	mText = Text
	DrawText
End Sub
Public Sub getText As String
	Return mText
End Sub
#End Region

#Region  TextSize 
Public Sub setTextSize(TextSize As Int)
	mTextSize = TextSize
	DrawText
End Sub
Public Sub getTextSize As Int
	Return mTextSize
End Sub
#End Region

#Region  TypeFace1 
Public Sub setTypeFace1(TypeFace1 As Typeface)
	mTypeFace1 = TypeFace1
	DrawText
End Sub
Public Sub getTypeFace1 As Typeface
	Return mTypeFace1
End Sub
#End Region

#Region  Align1 
Public Sub setAlign1(Align1 As String)
	mAlign1 = Align1
	DrawText
End Sub
Public Sub getAlign1 As String
	Return mAlign1
End Sub
#End Region

#Region  Text Color 
Public Sub setTextColor(TextColor As Int)
	mTextColor = TextColor
	DrawText
End Sub
Public Sub getTextColor As Int
	Return mTextColor
End Sub
#End Region

#Region  New Text Color 
Public Sub setNewTextColor(NewTextColor As Int)
	mNewTextColor = NewTextColor
	DrawText
End Sub
Public Sub getNewTextColor As Int
	Return mNewTextColor
End Sub
#End Region

#Region  Color 
Public Sub setColor(Color As Int)
	mColor = Color
	mBase.Color = mColor
	DrawText
End Sub
Public Sub getColor As Int
	Return mColor
End Sub
#End Region


Public Sub GetPanel As Panel
	Return pnlTextBack
End Sub

#End Region


#Region  + PUBLIC METHODS 

Public Sub StartChange
	mrecText.Initialize(0, 0, mSliceW, pnlTextFore.Height)
	DrawText
	pnlTextFore.Visible = True
	tmrText.Enabled = True
End Sub

#End Region


#Region  + RAISED EVENTS 

Private Sub ChangeCompleted
	If SubExists(mTarget, mEventName & "_ChangeCompleted") Then
		CallSub(mTarget, mEventName & "_ChangeCompleted")
	End If
End Sub

Private Sub pnlTextBack_Click
	If SubExists(mTarget, mEventName & "_Click") Then
		CallSub(mTarget, mEventName & "_Click")
	End If
End Sub

Private Sub pnlTextBack_LongClick
	If SubExists(mTarget, mEventName & "_LongClick") Then
		CallSub(mTarget, mEventName & "_LongClick")
	End If
End Sub

#End Region

	
#Region  + PRIVATE METHODS 

Private Sub DrawText
	mCnvText.Initialize(pnlTextBack)
	Private recEntirePanel As Rect
	recEntirePanel.Initialize(0, 0, pnlTextBack.Width, pnlTextBack.Height)
	
	' Horizontal alignment
	Select Case mAlign1
		Case "LEFT"
			X_CnvText = 0
			mrecText.Left = 0
			Max_X_CnvText = X_CnvText + mCnvText.MeasureStringWidth(mText, mTypeFace1, mTextSize) -1
		Case "CENTER"
			X_CnvText = pnlTextBack.Width /2
			mrecText.Left = X_CnvText / 2
			Max_X_CnvText = X_CnvText + mCnvText.MeasureStringWidth(mText, mTypeFace1, mTextSize) / 2
		Case "RIGHT"
			X_CnvText = pnlTextBack.Width
			mrecText.Left = pnlTextBack.Width - mCnvText.MeasureStringWidth(mText, mTypeFace1, mTextSize)
			Max_X_CnvText = X_CnvText
	End Select
	
	' Centers vertically
	Y_CnvText = (pnlTextBack.Height + mCnvText.MeasureStringHeight(mText, mTypeFace1, mTextSize)) /2

	' Cleans
	mCnvText.DrawRect(recEntirePanel, Colors.Transparent, True, 0)
	mCnvText.DrawText(mText, X_CnvText, Y_CnvText, mTypeFace1, mTextSize, mTextColor, mAlign1)

	mCnvText.Initialize(pnlTextFore)
	' Cleans
	mCnvText.DrawRect(recEntirePanel, Colors.Transparent, True, 0)
	mCnvText.DrawText(mText, X_CnvText, Y_CnvText, mTypeFace1, mTextSize, mNewTextColor, mAlign1)
End Sub

#End Region


#Region  + EVENTS 

Sub tmrText_Tick
	mCnvText.DrawRect(mrecText, Colors.Transparent, True, 0)
	pnlTextFore.Invalidate
	mrecText.Left = mrecText.Left + mSliceW
	If mrecText.Left >= Max_X_CnvText Then
		tmrText.Enabled = False
		pnlTextFore.Visible = False
		ChangeCompleted
	End If
End Sub

#End Region


